# External Data Feeds references

A push request property specifying which [External Data Feeds](/guides/personalization/sources/external-data-feeds/) should be invoked and with what parameters in order to support personalization from feed content.


{{< important >}}
You must first [create an external data feed in the dashboard](/docs/guides/personalization/sources/external-data-feeds/), then you can refer to its ID as the `name` in the feed references object. The Coupons service is a type of external data feed. See [Coupons](/docs/guides/personalization/sources/coupons/) for formatting and usage information.
{{< /important >}}

## Feed references object {#feedreferences}

An object used to indicate that an external data feed should be invoked, the name of the feed to invoke, and the way in which to invoke it. You can only include a feed if you include a `templates` object in the payload or set the `personalization` option to `true`.

[Jump to examples ↓](#feedreferences-examples)

- **`defaults`** `object`

  Default parameter values for your feed. These values override any defaults you set for your feed in the Airship Dashboard.

- **`feeds`** `array[object]` **REQUIRED**

  An array of feeds that you want to use to personalize your message.


**Used in:**

- [Create content template]({{< ref "/developer/rest-api/ua/operations/content/" >}}#createcontenttemplate)
- [Create or update content template by external ID]({{< ref "/developer/rest-api/ua/operations/content/" >}}#updatecontenttemplatebyexternalid)
- [List a specific schedule]({{< ref "/developer/rest-api/ua/operations/schedules/" >}}#getschedule)
- [List content templates]({{< ref "/developer/rest-api/ua/operations/content/" >}}#listcontenttemplates)
- [List schedules]({{< ref "/developer/rest-api/ua/operations/schedules/" >}}#getschedules)
- [Look up a content template]({{< ref "/developer/rest-api/ua/operations/content/" >}}#getcontenttemplate)
- [Look up a content template by external ID]({{< ref "/developer/rest-api/ua/operations/content/" >}}#getcontenttemplatebyexternalid)
- [Schedule a notification]({{< ref "/developer/rest-api/ua/operations/schedules/" >}}#schedulenotification)
- [Schedule a templated push]({{< ref "/developer/rest-api/ua/operations/personalization/" >}}#scheduletemplatedpush)
- [Schedule message with bulk ID]({{< ref "/developer/rest-api/ua/operations/bulk-sending/" >}}#schedulebulksendpush)
- [Send a push]({{< ref "/developer/rest-api/ua/operations/push/" >}}#sendpush)
- [Send message with bulk ID]({{< ref "/developer/rest-api/ua/operations/bulk-sending/" >}}#bulksendpush)
- [Update content template]({{< ref "/developer/rest-api/ua/operations/content/" >}}#updatecontenttemplate)
- [Update schedule]({{< ref "/developer/rest-api/ua/operations/schedules/" >}}#updateschedule)
- [Validate a push]({{< ref "/developer/rest-api/ua/operations/push/" >}}#validatepush)
- [Validate message with bulk ID]({{< ref "/developer/rest-api/ua/operations/bulk-sending/" >}}#validatebulksendpush)

**Examples**

*Example push external data feeds request*

```http
POST /api/push HTTP/1.1
Authorization: Basic <master authorization string>
Accept: application/vnd.urbanairship+json; version=3
Content-Type: application/json

 {
    "device_types": ["ios"],
    "audience": { "tag": "earlyBirds" },
    "notification": {
       "alert": "{{#feed \"featured_product\"}}Hello, {{user}}, could I interest you in {{product_name}} today?{{/feed}}"
    },
    "options": {
       "personalization": true
    },
    "feed_references": {
       "feeds": [
          {
             "name": "featured_product"
          }
       ],
       "defaults": {
          "featured_product": {
             "category": "featured"
          }
       }
    }
 }

```

```http
HTTP/1.1 202 Accepted
Content-Type: application/vnd.urbanairship+json; version=3
Content-Length: 123
Data-Attribute: push_ids

{
    "ok": true,
    "operation_id": "5e7852b0-6909-4e60-a73f-4d6b92d94c80",
    "push_ids": [
       "bf28d158-fefe-475a-9c2a-ed4f69cc891e"
    ]
}   

```

*Example feed references object*

```json
{
   "feed_references": {
      "feeds": [
         {
            "name": "featured_product",
            "params": {
               "sub_category": "shoes"
            },
            "on_error": "continue"
         }
      ],
      "defaults": {
         "featured_product": {
            "category": "featured"
         }
      }
   }
}

```

---

